import { useState } from 'react';
import { OpenAIApi, ChatCompletionRequestMessage } from 'openai';
import { InputWidget } from './InputWidget';
// import AIWidgetIcon from '../../../svgs/Icons/Media/AIWidget';
import AIWidgetIcon from '../../../svgs/Icons/Media/AIWidget';

interface MessageWidgetProps {
  openAIApi: OpenAIApi;
}
export default function UseDefaultIncomingMessageWidget({
  openAIApi,
}: MessageWidgetProps): InputWidget {
  // eslint-disable-next-line @typescript-eslint/no-unused-vars,@typescript-eslint/no-empty-function
  const fileToWidget = (file: File): void => {};

  const renderWidget = (): JSX.Element => {
    return <AIWidgetIcon applyZoom color="green" />;
    // return (
    //   <div
    //     style={{
    //       width: '48',
    //       height: '48',
    //       color: 'red',
    //       fontSize: '32px',
    //       fontStyle: 'bold',
    //       fontWeight: '900',
    //       border: '2px solid red',
    //     }}
    //   >
    //     Quick answer
    //   </div>
    // );
  };

  // async function getData(textToSend: string): Promise<string> {
  //   const response = await fetch(
  //     `https://func270519800.azurewebsites.net/api/TranslateTextToEng?text=${textToSend}`,
  //   );
  //
  //   console.log('getData: response: ', response);
  //   const data = await response.text();
  //
  //   console.log(
  //     'getData have response: ',
  //     JSON.stringify(data.replaceAll('\n\n', '')),
  //   );
  //
  //   return data.replaceAll('\n\n', '');
  // }

  async function getOpenAIApiData(textToSend: string): Promise<string> {
    let answerSuggetion = '';

    if (textToSend.length === 0) return answerSuggetion;

    try {
      const promt = `You are a customer support chat operator. Your goal is to provide helpful and informative responses to customer inquiries. Give a response to the next user's query, considering the entire conversation context, and use grammar and vocabulary at the A2-B2 level. Answer in the format of simple sentences. Issue:"${textToSend}"`;
      const messages: ChatCompletionRequestMessage[] = [
        {
          role: 'system',
          content: promt,
        },
        // ...dialogMessages,
      ];
      const { data } = await openAIApi.createChatCompletion({
        messages,
        model: 'gpt-3.5-turbo',
        temperature: 0.5,
      });

      answerSuggetion = data.choices[0]?.message?.content || '';
    } catch (error) {
      console.error('error in execute open AI calls', error);
    }

    return answerSuggetion;
  }

  const [textFromWidgetToInput, setTextFromWidgetToInput] = useState('');
  const textToWidget = (value: string): void => {
    if (value && value.length > 0) {
      // eslint-disable-next-line promise/catch-or-return,promise/always-return
      getOpenAIApiData(value).then((data) => {
        setTextFromWidgetToInput(data);
      });
    }
  };

  return {
    fileToInput: undefined,
    textToInput: textFromWidgetToInput,
    fileToWidget,
    renderWidget,
    textToWidget,
  };
}
